Name:           freemind
Version:        1.0.1
Release:        17%{?dist}
Summary:        Free mind mapping software

License:        GPLv2 and MIT
URL:            http://freemind.sourceforge.net
Source0:        http://downloads.sourceforge.net/project/%{name}/%{name}/%{version}/%{name}-src-%{version}.tar.gz
Source1:        freemind.desktop
Source2:        freemind.xml
Patch0:         0001-Fix-JOrtho-resource-lookup.patch
Patch1:         0002-Update-to-current-jgoodies-forms.patch
Patch2:         0003-Update-to-current-JMapViewer.patch
Patch3:         0004-Update-to-groovy-2.4.patch
Patch4:         0005-Adapt-launcher.patch
Patch5:         0006-Plugin-classpath.patch

BuildArch:      noarch
BuildRequires:  ant
BuildRequires:  avalon-framework
BuildRequires:  batik
BuildRequires:  bcel
BuildRequires:  desktop-file-utils
BuildRequires:  fop
BuildRequires:  groovy-lib
BuildRequires:  ImageMagick
BuildRequires:  java >= 1:1.6.0
BuildRequires:  javahelp2
BuildRequires:  jgoodies-forms >= 1.6.0
BuildRequires:  jibx
BuildRequires:  jmapviewer
BuildRequires:  jortho
BuildRequires:  javapackages-local
BuildRequires:  junit
BuildRequires:  log4j
BuildRequires:  SimplyHTML
BuildRequires:  xpp3
BuildRequires:  gnu-regexp
BuildRequires:  xerces-j2
BuildRequires:  apache-commons-lang

Requires:       %{name}-minimal = %{version}-%{release}
Requires:       %{name}-help = %{version}-%{release}
Requires:       %{name}-svg = %{version}-%{release}
Requires:       %{name}-map = %{version}-%{release}
Requires:       %{name}-collaboration-socket = %{version}-%{release}
Requires:       %{name}-script = %{version}-%{release}

%description
FreeMind is a premier free mind-mapping software written in Java. The
recent development has hopefully turned it into high productivity tool.
So you want to write a completely new metaphysics? Why don't you use
FreeMind? You have a tool at hand that remarkably resembles the tray
slips of Robert Pirsig, described in his sequel to Zen and the Art of
Motorcycle Maintenance called Lila. Do you want to refactor your essays
in a similar way you would refactor software? Or do you want to keep
personal knowledge base, which is easy to manage? Why don't you try
FreeMind? Do you want to prioritize, know where you are, where you've
been and where you are heading, as Stephen Covey would advise you? Have
you tried FreeMind to keep track of all the things that are needed for
that?

%package minimal
Summary:        Core FreeMind without plugins
Requires:       java
Requires:       jibx
Requires:       xpp3
Requires:       apache-commons-lang
Requires:       jgoodies-forms
Requires:       jortho
Requires:       xalan-j2
Requires:       xml-commons-apis
Requires:       xerces-j2
Requires:       SimplyHTML
Requires:       gnu-regexp
Requires:       hicolor-icon-theme
Requires:       xdg-utils

# Recommend default full JRE, because when people install third party JDK, it
# will satisfy the "java" requirement. But freemind would still be run with
# openjdk, which will likely be headless and make it crash
Recommends:     java-1.8.0-openjdk

%description minimal
%{summary}.

%package help
Summary:        Help plugin for FreeMind
Requires:       %{name}-minimal = %{version}-%{release}
Requires:       javahelp2

%description help
%{summary}.

%package svg
Summary:        SVG exporter for FreeMind
Requires:       %{name}-minimal = %{version}-%{release}
Requires:       batik
Requires:       fop
Requires:       xmlgraphics-commons
Requires:       xml-commons-apis
Requires:       rhino
Requires:       xerces-j2

%description svg
%{summary}.

%package map
Summary:        Map viewer plugin for FreeMind
Requires:       %{name}-minimal = %{version}-%{release}
Requires:       jmapviewer

%description map
%{summary}.

%package collaboration-socket
Summary:        Collaboration plugin for FreeMind
Requires:       %{name}-minimal = %{version}-%{release}

%description collaboration-socket
%{summary}.

%package script
Summary:        Groovy scripting plugin for FreeMind
Requires:       %{name}-minimal = %{version}-%{release}
Requires:       groovy-lib

%description script
%{summary}.

%package javadoc
Summary:        API documentation for %{name}

%description javadoc
This package contains the API documentation for %{name}.

%prep
%setup -q -n %{name}

%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1

sed -i 's/\r//' accessories/LICENSE.MIT

# set default lookandfeel to be gtk. Fixes bug #729487
sed -i 's/lookandfeel = default/lookandfeel = gtk/' \
        freemind.properties

find -name '*.class' -exec rm -f '{}' \;
find -name '*.jar' -exec rm -f '{}' \;
find -name '*.zip' -exec rm -f '{}' \;

chmod 744 check_for_duplicate_resources.sh

sed -ri 's/(<java(do)?c)/\1 encoding="UTF-8"/g' `find -name 'build*.xml'`

%build
ant all doc \
    -Djibxruntimelibs=`build-classpath jibx bcel` \
    -DformsLib=`build-classpath jgoodies-forms` \
    -DspellLib=`build-classpath jortho` \
    -DsimplyHtml=`build-classpath SimplyHTML` \
    -Dtest.reports='reports' \
    -Ddist='dist' \
    -Dbuild='build/calsses' \
    -Dtestbuild='build/testclasses' \
    -Dsrc_base_for_post='.' \
    -Dpost='post' \
    -Dadditional.lib=`build-classpath javahelp2 JMapViewer groovy batik \
                      avalon-framework-api fop`

%install
# jars
mkdir -p %{buildroot}%{_javadir}/%{name}
install -pm 644 dist/lib/freemind.jar %{buildroot}%{_javadir}/%{name}/%{name}.jar
install -pm 644 dist/lib/bindings.jar %{buildroot}%{_javadir}/%{name}/bindings.jar
install -pm 644 dist/browser/freemindbrowser.jar %{buildroot}%{_javadir}/%{name}/%{name}browser.jar

rm -r lib
mkdir lib
ln -s %{_javadir}/%{name}/%{name}.jar lib/
ln -s %{_javadir}/%{name}/bindings.jar lib/
# base dependencies
DEPS="jibx/run xpp3 commons-lang jgoodies-forms jgoodies-common
      jortho xalan-j2 xalan-j2-serializer xml-commons-apis xerces-j2
      SimplyHTML gnu-regexp mnemonicsetter"
# help plugin
DEPS="$DEPS javahelp2"
# svg export plugin
DEPS="$DEPS batik-all fop pdf-transcoder xmlgraphics-commons
      avalon-framework avalon-framework-api avalon-framework-impl
      commons-logging commons-io rhino xml-commons-apis
      xml-commons-apis-ext xerces-j2"
# map viewer plugin
DEPS="$DEPS JMapViewer"
# script plugin
DEPS="$DEPS groovy-all"

build-jar-repository lib "$DEPS"

mkdir -p %{buildroot}%{_datadir}/%{name}
cp -r lib %{buildroot}/%{_datadir}/%{name}/

cp -pr plugins/dist/plugins %{buildroot}%{_datadir}/%{name}/

# javadoc
mkdir -p %{buildroot}%{_javadocdir}/%{name}
mv dist/doc/javadoc/* %{buildroot}%{_javadocdir}/%{name}

mkdir -p %{buildroot}%{_bindir}
install -pm 755 freemind.sh %{buildroot}%{_bindir}/%{name}

# data needed to run freemind
mkdir -p %{buildroot}%{_datadir}/%{name}/accessories
cp -pr dist/accessories %{buildroot}%{_datadir}/%{name}

mkdir -p %{buildroot}%{_datadir}/%{name}/doc
cp -pr dist/doc %{buildroot}%{_datadir}/%{name}
cp -p dist/patterns.xml %{buildroot}%{_datadir}/%{name}

mkdir -p %{buildroot}%{_datadir}/%{name}/browser
rm dist/browser/freemindbrowser.jar
cp -pr dist/browser %{buildroot}%{_datadir}/%{name}
ln -s %{_javadir}/%{name}/freemindbrowser.jar %{buildroot}%{_datadir}/%{name}/browser/%{name}browser.jar

desktop-file-install --dir %{buildroot}%{_datadir}/applications %{SOURCE1}


mkdir -p %{buildroot}%{_datadir}/pixmaps
mkdir -p %{buildroot}%{_datadir}/icons/hicolor/16x16/apps
mkdir -p %{buildroot}%{_datadir}/icons/hicolor/32x32/apps
mkdir -p %{buildroot}%{_datadir}/icons/hicolor/48x48/apps

convert -scale 32 images/FreeMindWindowIcon.png \
%{buildroot}%{_datadir}/pixmaps/%{name}.png

for i in 16 32 48
do
   convert -scale $i images/FreeMindWindowIcon.png %{buildroot}%{_datadir}/icons/hicolor/${i}x${i}/apps/%{name}.png
done

mkdir -p %{buildroot}%{_datadir}/mime/packages
cp -a %{SOURCE2} %{buildroot}%{_datadir}/mime/packages/


%post
update-desktop-database &> /dev/null || :
touch --no-create %{_datadir}/icons/hicolor &>/dev/null || :
touch --no-create %{_datadir}/mime/packages &>/dev/null || :

%postun
update-desktop-database &> /dev/null || :
if [ $1 -eq 0 ] ; then
    touch --no-create %{_datadir}/icons/hicolor &>/dev/null
    gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
    update-mime-database %{_datadir}/mime &> /dev/null || :
fi

%posttrans
gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
update-mime-database %{?fedora:-n} %{_datadir}/mime &> /dev/null || :

%files
# metapackage to pull in all modules

%files minimal
%{_datadir}/applications/*%{name}.desktop
%{_datadir}/mime/packages/%{name}.xml
%{_datadir}/pixmaps/%{name}.png
%{_datadir}/icons/hicolor/16x16/apps/%{name}.png
%{_datadir}/icons/hicolor/32x32/apps/%{name}.png
%{_datadir}/icons/hicolor/48x48/apps/%{name}.png
%{_javadir}/%{name}
%{_datadir}/%{name}
%{_bindir}/%{name}
%exclude %{_datadir}/%{name}/plugins/*
%doc history.txt readme.txt
%license license accessories/LICENSE.MIT


%files help
%{_datadir}/%{name}/plugins/help
%{_datadir}/%{name}/plugins/FreemindHelp.xml

%files svg
%{_datadir}/%{name}/plugins/svg
%{_datadir}/%{name}/plugins/ExportSvg.xml

%files map
%{_datadir}/%{name}/plugins/map
%{_datadir}/%{name}/plugins/MapViewer.xml

%files collaboration-socket
%{_datadir}/%{name}/plugins/collaboration
%{_datadir}/%{name}/plugins/CollaborationSocket.xml

%files script
%{_datadir}/%{name}/plugins/script
%{_datadir}/%{name}/plugins/ScriptingEngine.xml

%files javadoc
%{_javadocdir}/%{name}


%changelog
* Wed May 02 2018 Michael Simacek <msimacek@redhat.com> - 1.0.1-17
- Recommend java-1.8.0-openjdk

* Wed Jul 26 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.1-16
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Fri Feb 10 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.1-15
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Wed Dec 07 2016 Michael Simacek <msimacek@redhat.com> - 1.0.1-14
- Add batik-all to classpath (Resolves rhbz#1402128)
- Simplify classpath handling
- Add requires on xdg-utils

* Wed Nov 02 2016 Michael Simacek <msimacek@redhat.com> - 1.0.1-13
- Add more missing classpath entries (jgoodies-common, avalon-framework-*)
- Don't rely on script being in /usr/bin

* Mon Oct 31 2016 Michael Simacek <msimacek@redhat.com> - 1.0.1-12
- Add missing empty %%files section to main package

* Fri Oct 21 2016 Michael Simacek <msimacek@redhat.com> - 1.0.1-11
- Fix missing mnemonicsetter classpath entry
- Split plugins into subpackages
- Fix plugin classpaths

* Wed Feb 03 2016 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.1-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Tue Jul 14 2015 Mikolaj Izdebski <mizdebsk@redhat.com> - 1.0.1-9
- Add build-requires on javapackages-local

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.1-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Mon Mar 16 2015 Michael Simacek <msimacek@redhat.com> - 1.0.1-7
- Include URL in exec line in desktop file (resolves rhbz#1180082)

* Thu Mar 12 2015 Michael Simacek <msimacek@redhat.com> - 1.0.1-6
- Port to current groovy
- Use groovy-lib as Requires

* Mon Sep 08 2014 Rex Dieter <rdieter@fedoraproject.org> 1.0.1-5
- update mime scriptlet

* Wed Aug 20 2014 Michael Simacek <msimacek@redhat.com> - 1.0.1-4
- Put freemind base dir on classpath (resolves rhbz#1114025)

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Sun Jun 01 2014 Michael Simacek <msimacek@redhat.com> - 1.0.1-2
- Force using Xalan as XSL transformer - solves conversion failure
- Use %%jpackage_script instead of source file

* Thu Apr 24 2014 Michael Simacek <msimacek@redhat.com> - 1.0.1-1
- Update to upstream version 1.0.1
- Specfile cleanup

* Mon Aug 05 2013 Johannes Lips <hannes@fedoraproject.org> 0.9.0-16
- fixed wrong build requires
- updated jibx version

* Sun Aug 04 2013 Johannes Lips <hannes@fedoraproject.org> 0.9.0-15
- fixed changelog dates

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.9.0-14
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Fri Jan 25 2013 Mary Ellen Foster <mefoster@gmail.com> 0.9.0-13
- Update to JGoodies Forms 1.6.0 API

* Thu Dec 27 2012 Johannes Lips <hannes@fedoraproject.org> 0.9.0-12
- fixed the freemind.xml to fix bug #890360

* Thu Jul 19 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.9.0-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Sun May 06 2012 Johannes Lips <hannes@fedoraproject.org> 0.9.0-10
- bumped the jibx version in the spec due to jibx update

* Fri Mar 30 2012 Johannes Lips <hannes@fedoraproject.org> 0.9.0-9
- fixed the startup script to find all necessary files
- fixes bug #800769

* Sun Jan 01 2012 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-8
- jgoodies build patch
- adjusted the freemind.sh to reflect those changes

* Wed Aug 31 2011 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-7
- bump release

* Tue Aug 23 2011 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-6
- added a patch to fix the javadoc build

* Tue Aug 23 2011 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-5
- Fix bug #729487 by setting gtk+ lookandfeel by default

* Thu Jul 07 2011 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-4
- added the avalon-framework-*.jars to the classpath freemind.sh


* Wed Jul 06 2011 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-3
- updated freemind.sh to reflect the version change of jibx
- added additional jar files to freemind.sh
- fixed the wrong directory of the scripting plugin

* Thu Jun 23 2011 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-2
- updated the version of the jibx jar files
- updated the svg build patch to reflect the changes to the avalon-framework

* Tue Feb 15 2011 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-1
- update to recent stable upstream version
- removed the firefox requirement

* Thu Jan 27 2011 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-0.10.rc15
- update to recent upstream version

* Fri Dec 24 2010 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-0.9.rc14
- update to recent upstream version

* Wed Dec 22 2010 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-0.9.rc13
- update to recent upstream version

* Thu Dec 16 2010 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-0.8.rc12
- update to recent upstream version

* Fri Nov 26 2010 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-0.7.rc11
- update to recent upstream version

* Fri Nov 26 2010 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-0.6.rc10
- added java as a build requirement
- changed the build-jar-repository process for jibx

* Fri Nov 26 2010 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-0.5.rc10
- added jibx as a requirement
- fixed the MIT license file
- minor formatting changes
- fixed the permissions of the sh file

* Fri Nov 19 2010 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-0.4.rc10
- removed the %%clean section
- removed unnecessary files in /usr/share/freemind
- removed the versioned javadoc directory
- replaced all jar files in /usr/share/freemind with symlinks
- added the LICENSE.MIT
- added a patch to remove the classpath in the manifest file

* Fri Nov 19 2010 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-0.3.rc10
- added a patch to include avalon-framework into the classpath for the svg plugin
- implemented a for loop for converting the icon files

* Wed Nov 17 2010 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-0.2.rc10
- removed the classpath patches and used build-jar-repository instead
- consistent usage of %%{buildroot}
- added ws-jaxme and log4j as build requirements
- renamed all the jakarta packages
- changed the group

* Wed Sep 29 2010 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-0.1.rc10
- update to recent upstream release candidate version
- removed the latex plugin which depends on HotEqn
- dropped the BuildRequires and Requires of HotEqn
- added a patch to build the svg plugin properly
- changed the version scheme
- added hicolor-icon-theme as a requirement
- added the %%post and %%postun section and added entries for mime-info, icon and desktop file

* Wed Sep 29 2010 Johannes Lips <Johannes.Lips googlemail com> 0.9.0.rc9-3
- added a freemind directory for all freemind jars

* Sat Sep 25 2010 Johannes Lips <Johannes.Lips googlemail com> 0.9.0.rc9-2
- changed the path to jar-files in freemind.sh

* Thu Sep 16 2010 Johannes Lips <Johannes.Lips googlemail com> 0.9.0.rc9-1
- initial fedora spec

